
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tree.h"
#include "ggc.h"
#include "c-common.h"
#include "langhooks.h"
#include "langhooks-def.h"
#include "flags.h"
#include "lex.h"
#include "ilog-tree.h"

enum 
ilog_tree_node_structure_enum ilog_tree_node_structure( union lang_tree_node *t ATTRIBUTE_UNUSED )
{

  switch ( TREE_CODE(&t->generic) ) {
  case ILOG_STRING:		return TS_ILOG_STRING;
  default:			return TS_ILOG_GENERIC;
  }
}


tree
build_ilog_string( const char *str )
{
  tree ret;
  int len = strlen( str );
  int size = sizeof(struct ilog_string) - 1 + (len+1);

  ret = ggc_alloc_tree( size );
  memset( ret, 0, sizeof(struct tree_common) );

  TREE_SET_CODE( ret, ILOG_STRING );
  
  ILOG_STRING_LENGTH(ret) = len;
  strcpy( ILOG_STRING_POINTER(ret), str );


  return ret;
}




size_t
ilog_tree_size( enum tree_code code ATTRIBUTE_UNUSED)
{
  switch ( code ) {
  default:
    abort();
  }
}
