
#include "debug.h"


#define DEFTREECODE(SYM,NAME,TYPE,LENGTH) SYM,
enum ilog_tree_code {
  ILOG_DUMMY_TREE_CODE = LAST_C_TREE_CODE,
#include "ilog-tree.def"
  LAST_ILOG_TREE_CODE
};



struct lang_identifier GTY(())
{
  struct tree_identifier common;
  enum TOK rid_code;
};

typedef struct lang_identifier ilog_identifier;

struct lang_type GTY(())
{
};

struct language_function GTY(())
{
};

struct lang_decl GTY(())
{
};





#define ILOG_STRING_T(NODE) ((struct ilog_string*)(ILOG_STRING_CHECK(NODE)))

#define ILOG_STRING_LENGTH(NODE) (ILOG_STRING_T(NODE)->length)
#define ILOG_STRING_POINTER(NODE) (ILOG_STRING_T(NODE)->buffer)
#define ILOG_STRING_SIZE(NODE) (sizeof(struct ilog_string) - 1 +ILOG_STRING_LENGTH(NODE) + 1)

struct ilog_string GTY(())
{
  struct tree_common common;
  int length;
  char buffer[1];
};

tree build_ilog_string( const char *str );
tree copy_ilog_string( tree str );




enum ilog_tree_node_structure_enum {
  TS_ILOG_GENERIC,
  TS_ILOG_STRING,
};

union lang_tree_node 
  GTY((desc ("ilog_tree_node_structure (&%h)"),
       chain_next ("(union lang_tree_node *)TREE_CHAIN (&%h.generic)")))
{
  union tree_node GTY ((tag ("TS_ILOG_GENERIC"), 
			desc ("tree_node_structure (&%h)"))) 
    generic;
  struct ilog_string GTY(( tag("TS_ILOG_STRING") )) ilog_string;
};

enum ilog_tree_node_structure_enum ilog_tree_node_structure( union lang_tree_node * );

size_t ilog_tree_size( enum tree_code code );


