
enum TOK {
  TOK_DIGCONST = 256,
  TOK_STRCONST,
  TOK_IDENT,
  TOK_IF,
  TOK_ELSE,
  TOK_WHILE,
  TOK_FOR,
  TOK_NAMESPACE,
  TOK_NLDEF,
  TOK_VAR,
  TOK_RETURN,
  TOK_FUNCTION,
  TOK_CONST,
  TOK_USING,

  TOK_DEFUN,
  TOK_DEFVAR,

  TOK_VOID,

  TOK_SCOPE_COLON,

  TOK_LSHIFT,			/* << */
  TOK_RSHIFT,			/* >> */
  TOK_GE,			/* >= */
  TOK_LE,			/* <= */
  TOK_EQUAL,			/* == */
  TOK_NE,			/* != */

  TOK_AMPAMP,			/* && */

  TOK_EOF,
  TOK_UNKNOWN
};

#define IS_EXPR_TOKEN(t) ( ((t)==TOK_DIGCONST) || ((t)==TOK_STRCONST) || ((t)==TOK_IDENT) )
#define IS_QUAL_TOKEN(t) ( ((t)==TOK_CONST) )


extern const char *lex_buffer;
extern int lex_cur_pos;
extern int lex_buffer_len;
extern int lex_last_token_head_pos;
extern int lex_last_token_tail_pos;

#define LEX_LAST_TOKEN_LEN (lex_last_token_tail_pos-lex_last_token_head_pos)
const char *last_token_str PARAMS((void));

bool init_lex_buffer PARAMS((const char*));
void set_lex_buffer PARAMS((const char *program));
void unset_lex_buffer PARAMS((void));
enum TOK next_token PARAMS((void));

extern enum TOK current_token;

void push_token PARAMS((enum TOK tok));	

void init_reswords PARAMS((void));

typedef union {
  char *str_value;
  tree tree_value;
  int int_value;
} lex_value_t ;

extern lex_value_t lex_value;
